#include "JentchinaTreeModel.h"
#include <glib.h>
#include <glib-object.h>
#include "../Central/JnaCnlIter.h"

#define VIRTUAL_FUNC() 	g_error("you should define your own function, this is a virtual method")

static gint
impl_JentchinaTreeModel_getNColumns		(JentchinaTreeModel* self)
{
	VIRTUAL_FUNC();
	return 0;
}

static GType
impl_JentchinaTreeModel_getColumnType 		(JentchinaTreeModel* self,
                             			 gint index)
{
	VIRTUAL_FUNC();
	return G_TYPE_INVALID;
}

static gboolean
impl_JentchinaTreeModel_getIter			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 char* path)
{
	VIRTUAL_FUNC();
	return FALSE;
}

static char* /* newly allocated */
impl_JentchinaTreeModel_getPath			(JentchinaTreeModel* self,
						 JentchinaIter iter)
{
	VIRTUAL_FUNC();
	return g_strdup("0");
}

static void
impl_JentchinaTreeModel_getValue		(JentchinaTreeModel* self,
						 JentchinaIter iter,
						 gint column,
						 GValue* out_value)
{
	VIRTUAL_FUNC();
	return;
}

static gboolean
impl_JentchinaTreeModel_iterNext		(JentchinaTreeModel* self,
						 JentchinaIter* inOut_iter)
{
	VIRTUAL_FUNC();
	return FALSE;
}

static gboolean
impl_JentchinaTreeModel_iterChildren		(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter parent)
{
	VIRTUAL_FUNC();
	return FALSE;
}

static gboolean
impl_JentchinaTreeModel_iterHasChild		(JentchinaTreeModel* self,
						 JentchinaIter iter)
{
	VIRTUAL_FUNC();
	return FALSE;
}

static gint
impl_JentchinaTreeModel_iterNChildren		(JentchinaTreeModel* self,
						 JentchinaIter iter)
{
	VIRTUAL_FUNC();
	return 0;
}

static gboolean
impl_JentchinaTreeModel_iterNthChild		(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter parent,
						 int n)
{
	VIRTUAL_FUNC();
	return FALSE;
}

static gboolean
impl_JentchinaTreeModel_iterParent		(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter child)
{
	VIRTUAL_FUNC();
	return FALSE;
}

static void
JentchinaTreeModelClass_init (JentchinaTreeModelClass *selfClass)
{
	selfClass->getNColumns=impl_JentchinaTreeModel_getNColumns;
	selfClass->getColumnType=impl_JentchinaTreeModel_getColumnType;
	selfClass->getIter=impl_JentchinaTreeModel_getIter;
	selfClass->getPath=impl_JentchinaTreeModel_getPath;
	selfClass->getValue=impl_JentchinaTreeModel_getValue;
	selfClass->iterNext=impl_JentchinaTreeModel_iterNext;
	selfClass->iterChildren=impl_JentchinaTreeModel_iterChildren;
	selfClass->iterHasChild=impl_JentchinaTreeModel_iterHasChild;
	selfClass->iterNChildren=impl_JentchinaTreeModel_iterNChildren;
	selfClass->iterNthChild=impl_JentchinaTreeModel_iterNthChild;
	selfClass->iterParent=impl_JentchinaTreeModel_iterParent;
}

GType		JentchinaTreeModel_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JentchinaTreeModelClass),
			NULL, NULL,
			(GClassInitFunc) JentchinaTreeModelClass_init,
			NULL, NULL,
			sizeof (JentchinaTreeModel),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JentchinaTreeModel", &info,  G_TYPE_FLAG_ABSTRACT);
	}

	return type;
}

gint
JentchinaTreeModel_getNColumns			(JentchinaTreeModel* self)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->getNColumns(self);
}

GType
JentchinaTreeModel_getColumnType 		(JentchinaTreeModel* self,
                             			 gint index)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->getColumnType(self, index);
}





gboolean
JentchinaTreeModel_getIter			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 char* path)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->getIter(self, out_iter, path);
}


char* /* newly allocated */
JentchinaTreeModel_getPath			(JentchinaTreeModel* self,
						 JentchinaIter iter)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->getPath(self, iter);
}


void
JentchinaTreeModel_getValue			(JentchinaTreeModel* self,
						 JentchinaIter iter,
						 gint column,
						 GValue* out_value)
{
	JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->getValue(self, iter, column, out_value);
}


gboolean
JentchinaTreeModel_iterNext			(JentchinaTreeModel* self,
						 JentchinaIter* inOut_iter)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->iterNext(self, inOut_iter);
}


gboolean
JentchinaTreeModel_iterChildren			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter parent)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->iterChildren(self, out_iter, parent);
}


gboolean
JentchinaTreeModel_iterHasChild			(JentchinaTreeModel* self,
						 JentchinaIter iter)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->iterHasChild(self, iter);
}


gint
JentchinaTreeModel_iterNChildren		(JentchinaTreeModel* self,
						 JentchinaIter iter)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->iterNChildren(self, iter);
}


gboolean
JentchinaTreeModel_iterNthChild			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter parent, 
						 int n)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->iterNthChild(self, out_iter, parent, n);
}


gboolean
JentchinaTreeModel_iterParent			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter child)
{
	return JENTCHINA_TREE_MODEL_CLASS(G_OBJECT_GET_CLASS(self))->iterParent(self, out_iter, child);
}

static void
impl_JentchinaTreeModel_printRecurse		(JentchinaTreeModel* self,
						 JentchinaIter iter,
						 int level,
						 int maxDepth,
						 int maxNext)
{
	char* fill;

	fill=g_strnfill(level, ' ');
	
	
	if(iter) {
		GValue value={G_TYPE_INVALID, NULL};

		g_print("iter='%ud'\n", iter);
		JnaCnlIter_print(iter);
  	
		JentchinaTreeModel_getValue(self, iter, 0, &value);

		g_print("%s%s\n", fill, g_value_get_string(&value));;
	}
	
	if((maxDepth==-1||level<maxDepth) && JentchinaTreeModel_iterHasChild(self, iter)) {
		int n=0;
		JentchinaIter child;
		
		g_return_if_fail(JentchinaTreeModel_iterChildren(self, &child, iter));
		g_return_if_fail(JnaCnlIter_isValid(child));

		g_print("child : ");
		JnaCnlIter_print(child);
		impl_JentchinaTreeModel_printRecurse(self, child, level+1, maxDepth, maxNext);
		while( (maxNext==-1||n<maxNext) && JentchinaTreeModel_iterNext(self, &child)) {
			impl_JentchinaTreeModel_printRecurse(self, child, level+1, maxDepth, maxNext);
			n++;
		}
	}
	
	g_free(fill);
}

void
JentchinaTreeModel_print			(JentchinaTreeModel* self, 
						 int maxDepth,	/* -1 if not used */
						 int maxNext)	/* -1 if not ued */
{
	g_print("Jentchina::API::TreeModel\n");
	impl_JentchinaTreeModel_printRecurse(self, 0, 0, maxDepth, maxNext);
}


