/* Jentchina - TreeModel
 * STRASSER Michel - 20040405		init
 * */

#ifndef __JENTCHINA_TREE_MODEL_H__
#define __JENTCHINA_TREE_MODEL_H__

#include <glib.h>
#include <glib-object.h>

#define	JENTCHINA_TYPE_TREE_MODEL			(JentchinaTreeModel_getType ())
#define JENTCHINA_TREE_MODEL(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JENTCHINA_TYPE_TREE_MODEL, JentchinaTreeModel))
#define JENTCHINA_TREE_MODEL_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JENTCHINA_TYPE_TREE_MODEL, JentchinaTreeModelClass))
#define JENTCHINA_IS_TREE_MODEL(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JENTCHINA_TYPE_TREE_MODEL))
#define JENTCHINA_IS_TREE_MODEL_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JENTCHINA_TYPE_TREE_MODEL))
#define JENTCHINA_TREE_MODEL_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JENTCHINA_TREE_MODEL_TYPE_NAME(object)	  (g_type_name (JENTCHINA_TREE_MODEL_TYPE (object)))

typedef struct _JentchinaTreeModel	JentchinaTreeModel;
typedef struct _JentchinaTreeModelClass	JentchinaTreeModelClass;

#ifndef JENTCHINA_ITER
#define JENTCHINA_ITER
typedef guint32 JentchinaIter;
#endif

struct _JentchinaTreeModel
{
	GObject 		parent_instance;
};

struct _JentchinaTreeModelClass
{
	GObjectClass 		parent_class;

	gint		(*getNColumns)			(JentchinaTreeModel* self);

	GType		(*getColumnType) 		(JentchinaTreeModel* self,
                             				 gint index);


	gboolean	(*getIter)			(JentchinaTreeModel* self,
							 JentchinaIter* out_iter,
							 char* path);

	char* 		(*getPath)			(JentchinaTreeModel* self,
							 JentchinaIter iter);

	void		(*getValue)			(JentchinaTreeModel* self,
							 JentchinaIter iter,
							 gint column,
							 GValue* out_value);

	gboolean	(*iterNext)			(JentchinaTreeModel* self,
							 JentchinaIter* inOut_iter);

	gboolean	(*iterChildren)			(JentchinaTreeModel* self,
							 JentchinaIter* out_iter,
							 JentchinaIter parent);

	gboolean	(*iterHasChild)			(JentchinaTreeModel* self,
							 JentchinaIter iter);

	gint		(*iterNChildren)		(JentchinaTreeModel* self,
							 JentchinaIter iter);

	gboolean	(*iterNthChild)			(JentchinaTreeModel* self,
							 JentchinaIter* out_iter,
							 JentchinaIter parent,
							 int n);

	gboolean	(*iterParent)			(JentchinaTreeModel* self,
							 JentchinaIter* out_iter,
							 JentchinaIter child);
};

G_BEGIN_DECLS

GType		
JentchinaTreeModel_getType		(void);

/* README :
 * 
 * There is no constructor since it is an abstract class 
 * People using this class through the API should get a reference of such an object by using 
 * a JentchinaObj like a factory 
 *
 * The API is optimized for bringing an implementation of a view in GTK with minimal
 * efforts. If one had not a MVC compliant GUI toolkit used over Jentchina, we may want to use 
 * the setData / getData methods in order to store for each node a reference to the "graphical node".
 * Cast any pointer to int in that case.
 * */

gint
JentchinaTreeModel_getNColumns			(JentchinaTreeModel* self);

GType
JentchinaTreeModel_getColumnType 		(JentchinaTreeModel* self,
                             			 gint index);

gboolean
JentchinaTreeModel_getIter			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 char* path);

char* /* newly allocated */
JentchinaTreeModel_getPath			(JentchinaTreeModel* self,
						 JentchinaIter iter);

void
JentchinaTreeModel_getValue			(JentchinaTreeModel* self,
						 JentchinaIter iter,
						 gint column,
						 GValue* out_value);

gboolean
JentchinaTreeModel_iterNext			(JentchinaTreeModel* self,
						 JentchinaIter* inOut_iter);

gboolean
JentchinaTreeModel_iterChildren			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter parent);

gboolean
JentchinaTreeModel_iterHasChild			(JentchinaTreeModel* self,
						 JentchinaIter iter);

gint
JentchinaTreeModel_iterNChildren		(JentchinaTreeModel* self,
						 JentchinaIter iter);

gboolean
JentchinaTreeModel_iterNthChild			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter parent,
						 int n);

gboolean
JentchinaTreeModel_iterParent			(JentchinaTreeModel* self,
						 JentchinaIter* out_iter,
						 JentchinaIter child);

void
JentchinaTreeModel_print			(JentchinaTreeModel* self,
						 int maxDepth,
						 int maxNext);

G_END_DECLS

#endif /* __JENTCHINA_TREE_MODEL_H__ */
