/* Jentchina -CnlFiltersTree
 * STRASSER Michel - 20040317		init
 * */

#include "JnaCnlFiltersTree.h"
#include "JnaCnlIter.h"
#include "JnaCnlServerFiltersTree.h"
#include "../XmlReaders/pack_XmlReaders.h"
#include <glib.h>
#include <glib-object.h>

static GObjectClass *jnaCnlFiltersTree_parentClass;

static void
impl_JnaCnlFiltersTree_finalize(GObject *object)
{
	JnaCnlFiltersTree *self=(JnaCnlFiltersTree*)object;
	GObject *l1=NULL, *l2=NULL;

	for(l1=self->first ; l1 ;) { 
		l2=l1;
		l1=JNA_CNL_SERVER_FILTERS_TREE(l1)->next;
		if(l2)
			g_object_unref(l2);
	}

	jnaCnlFiltersTree_parentClass->finalize(object);
}

static void
JnaCnlFiltersTreeClass_init (JnaCnlFiltersTreeClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	jnaCnlFiltersTree_parentClass = g_type_class_peek_parent (selfClass);

	objectClass->finalize=impl_JnaCnlFiltersTree_finalize;
}

GType		JnaCnlFiltersTree_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaCnlFiltersTreeClass),
			NULL, NULL,
			(GClassInitFunc) JnaCnlFiltersTreeClass_init,
			NULL, NULL,
			sizeof (JnaCnlFiltersTree),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaCnlFiltersTree", &info, 0);
	}

	return type;
}

GObject* 	
JnaCnlFiltersTree_new		(JnaCnlFiltersType filtersType)
{
	JnaCnlFiltersTree* retval;

	g_return_val_if_fail((filtersType==JnaCnlFiltersType__IMPORT)||(filtersType==JnaCnlFiltersType__EXPORT), NULL);
	
	retval=g_object_new(JNA_TYPE_CNL_FILTERS_TREE, NULL);
	
	retval->filtersType=filtersType;
	retval->first=NULL;
	retval->last=NULL;
	retval->nServers=0;

	return (GObject*) retval;
}

void 
JnaCnlFiltersTree_print			(JnaCnlFiltersTree* self)
{
	GObject *l1, *l2;

	g_return_if_fail(JNA_IS_CNL_FILTERS_TREE(self));

	for(l1=self->first ; l1 ;) { 
		l2=l1;
		l1=JNA_CNL_SERVER_FILTERS_TREE(l1)->next;
		if(l2)
			JnaCnlServerFiltersTree_print(JNA_CNL_SERVER_FILTERS_TREE(l2));
	}
}

void 
JnaCnlFiltersTree_merge			(JnaCnlFiltersTree* self,
					 GObject* xServer,	/* JnaXServerInfoReader */
					 GObject* xTree)	/* JnaXFiltersTreeReader */
{
	GObject* server;

	g_return_if_fail(JNA_IS_CNL_FILTERS_TREE(self));
	g_return_if_fail(JNA_IS_X_SERVER_INFO_READER(xServer));
	g_return_if_fail(JNA_IS_X_FILTERS_TREE_READER(xTree));

	server=JnaCnlServerFiltersTree_new(xServer, xTree, self->nServers, self->last);

	if(!self->first) {
		self->first=self->last=server;
	}
	else {
		JNA_CNL_SERVER_FILTERS_TREE(self->last)->next=server;
		self->last=server;
	}

	self->nServers++;
}

char* /* newly allocated */
JnaCnlFiltersTree_getFilterPath		(JnaCnlFiltersTree* self,
					 JnaCnlIter iter)
{
	char* retval;

	return retval;
}

gboolean
JnaCnlFiltersTree_getServerInfos	(JnaCnlFiltersTree* self,
					 JnaCnlIter iter,
					 char** out_domain,	/* newly allocated */
					 char** out_id)		/* newly allocated */
{
	gboolean retval;

	return retval;
}

#if 0
static GObject*
impl_JnaCnlFiltersTree_getServer	(JnaCnlFiltersTree* self,
					 JnaCnlIter iter)
{
	GObject* retval;

	int sNum;
	int i;
	GList* l; 

	sNum=JnaCnlIter_getServerNumber(iter);
	
	g_return_val_if_fail(sNum < self->nServers, NULL);

	l=self->servers;
	
	for(i=0 ; i < sNum ; i++)
		l=g_list_next(l);

	g_return_val_if_fail(JNA_IS_CNL_FILTERS
	
	return retval;
}
#endif

int
JnaCnlFiltersTree_getData		(JnaCnlFiltersTree* self,
					 JnaCnlIter iter)
{
	int retval;

	
	
	return retval;
}

void
JnaCnlFiltersTree_setData		(JnaCnlFiltersTree* self,
					 JnaCnlIter iter,
					 int data)
{
}



