#ifndef __JNA_CNL_ITER__
#define __JNA_CNL_ITER__

#include <glib.h>

typedef guint32 JnaCnlIter;
/*
 * 	31 30 29 28 27 26 25 24 23 22 21 20 19 18 17 16 15 14 13 12 11 10 9 8 7 6 5 4 3 2 1 0
 *     |  |                                            |                                   |1|
 *      FilterType	Server				 NodeNumber			    Last bit always 1
 *      1 bit		15 bits=32768 servers		 15 bits=32768 filters/server	    So a valid JnaCnlIter is never 0
 */

G_BEGIN_DECLS

JnaCnlIter
JnaCnlIter_new				(int filterType,
					 int server,
					 int nodeNumber);

gboolean
JnaCnlIter_isValid			(JnaCnlIter self);

int
JnaCnlIter_getFilterType		(JnaCnlIter self);

int
JnaCnlIter_getServerNumber		(JnaCnlIter self);

int
JnaCnlIter_getNodeNumber		(JnaCnlIter self);

void
JnaCnlIter_getAllFast			(JnaCnlIter self,
					 int* filterType,
					 int* serverNumber,
					 int* nodeNumber);

void
JnaCnlIter_print			(JnaCnlIter self);

G_END_DECLS

#endif
