/* Jentchina - Communication sub system
 * STRASSER Michel - 20040201		init
 * */

#ifndef __JNA_COM_H__
#define __JNA_COM_H__

#include <glib.h>
#include <glib-object.h>


#define	JNA_TYPE_COM			(JnaCom_getType ())
#define JNA_COM(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_COM, JnaCom))
#define JNA_COM_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_COM, JnaComClass))
#define JNA_IS_COM(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_COM))
#define JNA_IS_COM_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_COM))
#define JNA_COM_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_COM_TYPE_NAME(object)	  (g_type_name (JNA_COM_TYPE (object)))

typedef struct _JnaCom		JnaCom;
typedef struct _JnaComClass	JnaComClass;

typedef enum {
	JNA_COM_FILTER_TYPE__IMPORT,
	JNA_COM_FILTER_TYPE__EXPORT
} JnaComFilterType;


struct _JnaCom
{
	GObject 		parent_instance;
};

struct _JnaComClass
{
	GObjectClass 		parent_class;

	GObject*
		(*getRendezVous)	(JnaCom* self,
					 JnaComFilterType filterType,
					 char* filterName,
					 char* user,
					 char* password,
					 GObject* lsmStream, // JnaStream
					 GObject** out_comException); // JnaComException 

	/* returns a JnaStream, that contains a lsmStream */
	GObject*
		(*applyFilter)		(JnaCom* self,
					 char* sessionKey,
					 GObject* interfacesStream,
					 GObject** out_comException);

	/* returns a JnaStream, that contains a PNG picture, an xml stream, etc ...  */
	GObject*
		(*getRessource)		(JnaCom* self,
					 char* ressourcePath,
					 GObject** out_comException);

};

G_BEGIN_DECLS

GType		
JnaCom_getType			(void);


/* JnaCom is a virtual class :
 * that's why there is no constructor
 * */

/* returns a JnaComRendezVous object*/
GObject*
JnaCom_getRendezVous		(JnaCom* self,
				 JnaComFilterType filterType,
				 char* filterName,
				 char* user,
				 char* password,
				 GObject* lsmStream,
				 GObject** out_comException);


/* returns a JnaStream, that contains a lsmStream */
GObject*
JnaCom_applyFilter		(JnaCom* self,
				 char* sessionKey,
				 GObject* interfacesStream,
				 GObject** out_comException);

/* returns a JnaStream, that contains a PNG picture, an xml stream, etc ...  */
GObject*
JnaCom_getRessource		(JnaCom* self,
				 char* ressourcePath,
				 GObject** out_comException);


G_END_DECLS

#endif /* __JNA_COM_H__ */
