/* Jentchina - Communication sub system
 * STRASSER Michel - 20040131		init
 * */

#ifndef __JNA_COM_EXCEPTION_H__
#define __JNA_COM_EXCEPTION_H__

#include <glib.h>
#include <glib-object.h>

#define	JNA_TYPE_COM_EXCEPTION			(JnaComException_getType ())
#define JNA_COM_EXCEPTION(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_COM_EXCEPTION, JnaComException))
#define JNA_COM_EXCEPTION_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_COM_EXCEPTION, JnaComExceptionClass))
#define JNA_IS_COM_EXCEPTION(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_COM_EXCEPTION))
#define JNA_IS_COM_EXCEPTION_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_COM_EXCEPTION))
#define JNA_COM_EXCEPTION_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_COM_EXCEPTION_TYPE_NAME(object)	  (g_type_name (JNA_COM_EXCEPTION_TYPE (object)))

typedef struct _JnaComException	JnaComException;
typedef struct _JnaComExceptionClass	JnaComExceptionClass;

typedef enum {
	JNA__COM_EXCEPTION__None,
	JNA__COM_EXCEPTION__BadFilterName,
	JNA__COM_EXCEPTION__BadLogin,
	JNA__COM_EXCEPTION__FilterError,
	JNA__COM_EXCEPTION__InvalidInterfacesStream,
	JNA__COM_EXCEPTION__InvalidLsmStream,
	JNA__COM_EXCEPTION__BadDocument,
	JNA__COM_EXCEPTION__BadRessourcePath,
	JNA__COM_EXCEPTION__BadSessionKey,
	JNA__COM_EXCEPTION__SessionTimedOut,
	JNA__COM_EXCEPTION__System,
	JNA__COM_EXCEPTION__Last
} JnaComExceptionType;

struct _JnaComException
{
	GObject 		parent_instance;
	JnaComExceptionType 	type;
	char* 			mesg;
};

struct _JnaComExceptionClass
{
	GObjectClass 		parent_class;
};

G_BEGIN_DECLS

GType		
JnaComException_getType		(void);

/* mesg is copied, so you can free it */
GObject* 	
JnaComException_new			(JnaComExceptionType type,	
					 char* mesg);


/* allocated dynamically */
char*
JnaComException_toString		(JnaComException* self);

void
JnaComException_print			(JnaComException* self);

G_END_DECLS

#endif /* __JNA_COM_EXCEPTION_H__ */
