/* Jentchina - Communication sub system - Communication object factory
 * STRASSER Michel - 20040305		init
 * */

#ifndef __JNA_COM_FACTORY_H__
#define __JNA_COM_FACTORY_H__

#include <glib.h>
#include <glib-object.h>


#define	JNA_TYPE_COM_FACTORY			(JnaComFactory_getType ())
#define JNA_COM_FACTORY(object)		(G_TYPE_CHECK_INSTANCE_CAST ((object), JNA_TYPE_COM_FACTORY, JnaComFactory))
#define JNA_COM_FACTORY_CLASS(object)		(G_TYPE_CHECK_CLASS_CAST ((object), JNA_TYPE_COM_FACTORY, JnaComFactoryClass))
#define JNA_IS_COM_FACTORY(object)		(G_TYPE_CHECK_INSTANCE_TYPE((object), \
							JNA_TYPE_COM_FACTORY))
#define JNA_IS_COM_FACTORY_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE((klass), \
							JNA_TYPE_COM_FACTORY))
#define JNA_COM_FACTORY_TYPE(object)		  (G_TYPE_FROM_INSTANCE (object))
#define JNA_COM_FACTORY_TYPE_NAME(object)	  (g_type_name (JNA_COM_FACTORY_TYPE (object)))

typedef struct _JnaComFactory	JnaComFactory;
typedef struct _JnaComFactoryClass	JnaComFactoryClass;
typedef GObject* (*JnaComFactoryComConstructor)	(char* opt);

struct _JnaComFactory
{
	GObject 	parent_instance;
	GHashTable*	comConstructors;
};

struct _JnaComFactoryClass
{
	GObjectClass parent_class;
};

G_BEGIN_DECLS

GType		
JnaComFactory_getType		(void);

GObject* 	
JnaComFactory_new			();

GObject*
JnaComFactory_getNewCom			(JnaComFactory* self,
					 char* strategy,
					 char* opt);

GObject*
JnaComFactory_getNewComFromXServer	(JnaComFactory* self,
					 GObject* xServer); // JnaXServer


G_END_DECLS

#endif /* __JNA_COM_FACTORY_H__ */
