/* Jentchina - GrbURL 
 * STRASSER Michel - 20040508		init
 * */


#include "JnaGrbURL.h"
#include <glib.h>
#include <glib-object.h>
#include <libgnomevfs/gnome-vfs.h>

static GObjectClass *jnaGrbURL_parentClass;

static void
impl_JnaGrbURL_finalize(GObject *object)
{
	JnaGrbURL *self=(JnaGrbURL*)object;

	g_free(self->stream);
	
	jnaGrbURL_parentClass->finalize(object);
}

static void
JnaGrbURLClass_init (JnaGrbURLClass *selfClass)
{
	GObjectClass *objectClass = (GObjectClass *)selfClass;
	jnaGrbURL_parentClass = g_type_class_peek_parent (selfClass);

	/* initialising GNOME VFS */
	gnome_vfs_init();
	
	objectClass->finalize=impl_JnaGrbURL_finalize;
}

GType		JnaGrbURL_getType		(void)
{
	static GType type = 0;

	if (!type) {
		GTypeInfo info = {
			sizeof (JnaGrbURLClass),
			NULL, NULL,
			(GClassInitFunc) JnaGrbURLClass_init,
			NULL, NULL,
			sizeof (JnaGrbURL),
			0,
			NULL, NULL
		};

		type = g_type_register_static (
			G_TYPE_OBJECT,
			"JnaGrbURL", &info, 0);
	}

	return type;
}

static void
impl_JnaGrbURL_printError 			(GnomeVFSResult result, const char *uriString)
{
	const char *errorString;
	/* get the string corresponding to this GnomeVFSResult value */
	errorString = gnome_vfs_result_to_string (result);
	printf ("Error %s occured opening location %s\n", errorString, uriString);
}


#define JnaGrbURL_new_IF_ERROR() \
	if (result != GNOME_VFS_OK) {	\
		impl_JnaGrbURL_printError(result, url);	\
		return NULL;	\
	}


static void
impl_JnaGrbURL_calculateCheckSum		(JnaGrbURL* self)
{
	int i;
	self->checkSum=0;

	for(i=0 ; self->stream[i] ; i++) {
		int a=self->stream[i];
		
		self->checkSum+=((a+1)*a+1)*a;
	}
}

GObject* 	
JnaGrbURL_new				(char* url)
{
	JnaGrbURL* retval;
	GnomeVFSHandle *read_handle;
	GnomeVFSResult result;
	int length;
	GnomeVFSFileInfo info;
	GnomeVFSFileSize bytesRead;

	g_return_val_if_fail(url, NULL);
	
	retval=g_object_new(JNA_TYPE_GRB_URL, NULL);
	result = gnome_vfs_open (&read_handle, url, GNOME_VFS_OPEN_READ);
	JnaGrbURL_new_IF_ERROR();
	result=gnome_vfs_get_file_info_from_handle(read_handle,  &info, 0);
	JnaGrbURL_new_IF_ERROR();
	length=info.size;
	retval->stream=g_new0(char, length+1);
	result = gnome_vfs_read (read_handle, retval->stream, length, &bytesRead);
	JnaGrbURL_new_IF_ERROR();
	impl_JnaGrbURL_calculateCheckSum(retval);
	
	return (GObject*) retval;
}

